-- & was here

freeslot(
	"SPR2_BIKE",
	"S_SHADOW_BIKE"
)

states[S_SHADOW_BIKE] = {
	sprite = SPR_PLAY,
	frame = SPR2_BIKE,
	tics = -1,
	--action = A_SetPAnim,
	--var2 = PA_ABILITY,
	nextstate = S_PLAY_STND,
}

local cool = {
	"sfx_notevn", "(gloat)",
	"sfx_nottof", "(gloat)",
	"sfx_ndefet", "(gloat)",
	"sfx_outway", "\"Out of my way!\"",
	"sfx_behold", "\"Behold, the ultimate power!\"",
	-- AMPERSAND DON'T FORGET TO ADD THEM GOD FUCKING DAMNIT
	
	"sfx_adios2", "Soft pillow sounds",
	"sfx_recbig", "Great ground reception",
	"sfx_recsml", "Ground reception",
	"sfx_bturbo", "Boosting!",
	"sfx_bkjump", "Swift upwards motion",
	"sfx_cgjump", "[Jump ready!]",
	"sfx_tmpwrn", "[HP Warning!]",
	"sfx_bkskid", "Drifting",
	"sfx_bkhit1", "Hitting a wall",
	"sfx_bkhit2", "Hit a wall way too hard",
	"sfx_bkpstl", "Rifle shot",
	"sfx_lzrdie", "Projectile is gone",
	
	"sfx_bikget", "Gunshot but Awesome",
	
	"sfx_exhst1", "Exhaust noise",
	"sfx_exhst2", "Exhaust noise",
	"sfx_exhst3", "Exhaust noise",
	"sfx_politi", "aieeeee",
}
for i = 1,#cool,2 do
	local sfx = cool[i]
	freeslot(sfx)
	sfxinfo[_G[sfx]].caption = cool[i+1]
end
sfxinfo[sfx_adios2].flags = SF_X2AWAYSOUND

// TVOWA0.lmp
freeslot(
	"SPR_TVOW",
	"MT_SHADOW_BOX",
	"MT_SHADOW_ICON",
	"S_SHADOW_BOX",
	"S_SHADOW_ICON1",
	"S_SHADOW_ICON2",
	
	"SPR_LOZR",
	"MT_BOIKEBOOLET",
	"MT_BOIKEBOOLETEXHOOST",
	"S_BOIKEBOOLET"
)

local interactions = {}

rawset(_G, "AddBikeTvInteraction", function(skin, func)
	interactions[skin] = func
end)

AddBikeTvInteraction("shadow", function(m, v1, v2)
	local p = m.player
	if p.shadow then // Duh.
		p.shadow.bike = $ + 45*TICRATE
		if p.sbike then
			p.sbike.starttime = p.shadow.bike -- (extend)
		end
	end
end)

function A_ThisActionGrantsShadowAMotorcycle(a, v1, v2)
	if a then
		if a.target and a.target.valid and a.target.player then
			local m = a.target
			local p = m.player
			// Bike stuff here
			/*
			if m.skin ~= "shadow" then
				//print("Interactions with anyone else that isn't Shadow haven't been implemented yet")
				CONS_Printf(p, "This monitor has no interaction set with "..skins[a.skin].realname..".")
				S_StartSound(m, sfx_lose)
			end
			if p.shadow then
				p.shadow.bike = $ + 45*TICRATE
				if p.sbike then
					p.sbike.starttime = p.shadow.bike -- (extend)
				end
			end
			*/
			local func = interactions[m.skin]
			if func ~= nil then func(m, v1, v2)
			else
				CONS_Printf(p, "This monitor has no interaction set with "..skins[m.skin].realname..".")
				S_StartSound(m, sfx_lose)
			end
		end
	end
end

mobjinfo[MT_SHADOW_BOX] = {
	spawnstate = S_SHADOW_BOX,
	spawnhealth = 1,
	radius = 18*FRACUNIT,
	height = 40*FRACUNIT,
	speed = 1,
	damage = MT_SHADOW_ICON,
	deathsound = sfx_pop,
	deathstate = S_BOX_POP1,
	flags = MF_SOLID|MF_SHOOTABLE|MF_MONITOR
}
states[S_SHADOW_BOX] = {SPR_TVOW, A, 2, nil, 0, 0, S_BOX_FLICKER}

mobjinfo[MT_SHADOW_ICON] = {
	spawnstate = S_SHADOW_ICON1,
	spawnhealth = 1,
	radius = 8*FRACUNIT,
	height = 14*FRACUNIT,
	speed = 2*FRACUNIT,
	damage = 62*FRACUNIT,
	reactiontime = 8,
	seesound = sfx_shield,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY|MF_BOXICON
}

// {SPR_DFLM, FF_FULLBRIGHT|TR_TRANS40|B, 1, A_MoveRelative, 0, 5, S_FLAMEJETFLAMEB2}
states[S_SHADOW_ICON1] = {SPR_TVOW, FF_ANIMATE|C, 18, nil, 3, 4, S_SHADOW_ICON2}
states[S_SHADOW_ICON2] = {SPR_TVOW,            C, 18, A_ThisActionGrantsShadowAMotorcycle, 69, 420, S_NULL}


mobjinfo[MT_BOIKEBOOLET] = {
	spawnstate = S_BOIKEBOOLET,
	spawnhealth = 69,
	radius = 12*FRACUNIT,
	height = 24*FRACUNIT,
	flags = mobjinfo[MT_TURRETLASER].flags,
} // remembering? ew
mobjinfo[MT_BOIKEBOOLETEXHOOST] = {
	spawnstate = S_BOIKEBOOLET,
	spawnhealth = 69,
	radius = 12*FRACUNIT,
	height = 24*FRACUNIT,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY,
} // remembering? ew
states[S_BOIKEBOOLET] = {
	sprite = SPR_LOZR,
	frame = A,
	tics = -1,
	nextstate = S_BOIKEBOOLET
}



